<?php
/**
 * @author 林海涛
 * @date 2024/7/15 下午3:41
 */


namespace app\api\lists;


use app\common\model\goods\Goods;
use app\common\lists\ListsSearchInterface;
use app\common\model\goods_category\GoodsCategory;
use app\common\service\FileService;
use think\db\Query;


/**
 * Goods列表
 * Class GoodsLists
 * @package app\adminapi\listsgoods
 */
class FirmGoodLists extends BaseApiDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/07/07 18:37
     */
    public function setSearch(): array
    {
        return [
            '=' => ['goods_status'],
            '%like%' => ['goods_name', 'goods_brand'],
            'between' => ['service_total', 'service_fee'],
        ];
    }

    public function queryWhere()
    {
        $where = [];
        $where[] = ['user_id','=',$this->userId];
        if (!empty($this->params['goods_category_id'])) {
            $goodsCategoryId = end($this->params['goods_category_id']);
            $goodsCategoryData = GoodsCategory::where(['status' => 1])->order(['pid' => 'asc', 'weigh' => 'desc', 'id' => 'desc'])
                ->select()->toArray();
            $ids = get_tree_ids($goodsCategoryData, $goodsCategoryId);
            $ids[] = $goodsCategoryId;
            $where[] = ['goods_category_id', 'in', $ids];
        }
        // 创建时间
        if (!empty($this->params['create_time'])) {
            $time = [strtotime($this->params['create_time'][0]), strtotime($this->params['create_time'][1])];
            $where[] = ['create_time', 'between', $time];
        }
        //更新时间
        if (!empty($this->params['update_time'])) {
            $time = [strtotime($this->params['update_time'][0]), strtotime($this->params['update_time'][1])];
            $where[] = ['update_time', 'between', $time];
        }
        return $where;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/07/07 18:37
     */
    public function lists(): array
    {
        $lists = Goods::order(['id' => 'desc'])
            ->with(['goods_category' => function (Query $query) {
                $query->visible(['name']);
            }])
            ->where($this->searchWhere)
            ->where($this->queryWhere())
            ->limit($this->limitOffset, $this->limitLength)
            ->select()
            ->toArray();
        $goodsCategoryObj = GoodsCategory::where(['status' => 1])->order(['pid' => 'asc', 'weigh' => 'desc', 'id' => 'desc'])
            ->select();
        foreach ($lists as &$item) {
            $item['goods_category_ids'] = array_map("intval", $item['goods_category_ids']);
            $item['goods_category_ids_str'] = implode(' / ', $goodsCategoryObj->whereIn('id', $item['goods_category_ids'])->column('name'));
            $item['goods_image'] = $item['goods_image'] ? FileService::getFileUrl($item['goods_image']) : null;
            $item['goods_video'] = $item['goods_video'] ? FileService::getFileUrl($item['goods_video']) : null;
        }
        return $lists;
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/07/07 18:37
     */
    public function count(): int
    {
        return Goods::where($this->searchWhere)->where($this->queryWhere())->count();
    }

}